diff --git a/src/BRepBlend/BRepBlend_SurfRstLineBuilder.cxx b/src/BRepBlend/BRepBlend_SurfRstLineBuilder.cxx
index 40adf8d..81095fd 100644
--- a/src/BRepBlend/BRepBlend_SurfRstLineBuilder.cxx
+++ b/src/BRepBlend/BRepBlend_SurfRstLineBuilder.cxx
@@ -176,17 +176,16 @@ Standard_Integer BRepBlend_SurfRstLineBuilder::
   if(byinter) previousP.ParametersOnS(uprev,vprev);
   pt2d.SetCoord(theSol(1),theSol(2));
   lastpt2d.SetCoord(uprev,vprev);
-  domain1->Init();
+  myDomain1->Init();
 
-  while (domain1->More()) {
+  while (myDomain1->More()) {
     nbarc++; ok = 0;
     if(byinter) { 
-      ok = okinter = BRepBlend_BlendTool::Inters(pt2d,lastpt2d,
-						 surf1,
-						 domain1->Value(),prm,dist); 
+      ok = okinter = BRepBlend_BlendTool::Inters(pt2d,lastpt2d, surf1,
+						 myDomain1->Value(),prm,dist); 
     }
     if(!ok) ok = BRepBlend_BlendTool::Project(pt2d,surf1,
-					      domain1->Value(),prm,dist);
+                                              myDomain1->Value(), prm, dist);
 
     if (ok && (nbarc != PrevIndex) ) {
       if (dist<distmin || okinter) {
@@ -196,7 +195,7 @@ Standard_Integer BRepBlend_SurfRstLineBuilder::
 	if(okinter && (PrevIndex==0) ) break;
       }
     }
-    domain1->Next();
+    myDomain1->Next();
   }
   return IndexSol;
 }
@@ -212,8 +211,8 @@ BRepBlend_SurfRstLineBuilder::BRepBlend_SurfRstLineBuilder
  const Handle(Adaptor3d_HSurface)&  Surf2,
  const Handle(Adaptor2d_HCurve2d)&  Rst,
  const Handle(Adaptor3d_TopolTool)& Domain2):
- sol(1,3),surf1(Surf1), domain1(Domain1),
- surf2(Surf2), rst(Rst), domain2(Domain2)
+ sol(1, 3), surf1(Surf1), myDomain1(Domain1),
+ surf2(Surf2), rst(Rst), myDomain2(Domain2)
 {
 }
 
@@ -231,7 +230,7 @@ void BRepBlend_SurfRstLineBuilder::Perform(Blend_SurfRstFunction&  Func,
 					   const Standard_Real     MaxStep,
 					   const Standard_Real     TolGuide,
 					   const math_Vector&      ParDep,
-					   const Standard_Real     Tolesp,
+					   const Standard_Real     the3DTolEsp,
 					   const Standard_Real     Fleche,
 					   const Standard_Boolean  Appro) 
 {
@@ -239,7 +238,7 @@ void BRepBlend_SurfRstLineBuilder::Perform(Blend_SurfRstFunction&  Func,
   iscomplete = Standard_False;
   comptra = Standard_False;
   line = new BRepBlend_Line();
-  tolesp = Abs(Tolesp);
+  my3DTolEsp = Abs(the3DTolEsp);
   tolgui = Abs(TolGuide);
   fleche = Abs(Fleche);
   rebrou = Standard_False;
@@ -260,10 +259,10 @@ void BRepBlend_SurfRstLineBuilder::Perform(Blend_SurfRstFunction&  Func,
   if (Appro) {
     TopAbs_State siturst,situs;
     Standard_Boolean decroch;
-    math_Vector tolerance(1,3),infbound(1,3),supbound(1,3);
-    Func.GetTolerance(tolerance,tolesp);
+    math_Vector aVTol2D(1,3),infbound(1,3),supbound(1,3);
+    Func.GetTolerance(aVTol2D, my3DTolEsp);
     Func.GetBounds(infbound,supbound);
-    math_FunctionSetRoot rsnld(Func,tolerance,30);
+    math_FunctionSetRoot rsnld(Func, aVTol2D, 30);
     
     rsnld.Perform(Func,ParDep,infbound,supbound);
     
@@ -294,10 +293,10 @@ void BRepBlend_SurfRstLineBuilder::Perform(Blend_SurfRstFunction&  Func,
   previousP.ParametersOnS(U,V);
 //  W = previousP.ParameterOnC();
   
-  BRepBlend_Extremity ptf1(previousP.PointOnS(),
-			   U,V,previousP.Parameter(),tolesp);
-  BRepBlend_Extremity ptf2(previousP.PointOnC(),
-			   U,V,previousP.Parameter(),tolesp);
+  BRepBlend_Extremity ptf1(previousP.PointOnS(), U, V,
+                           previousP.Parameter(), my3DTolEsp);
+  BRepBlend_Extremity ptf2(previousP.PointOnC(), U, V, 
+                           previousP.Parameter(), my3DTolEsp);
   if (!previousP.IsTangencyPoint()) {
     ptf1.SetTangent(previousP.TangentOnS());
     ptf2.SetTangent(previousP.TangentOnC());
@@ -326,7 +325,7 @@ Standard_Boolean BRepBlend_SurfRstLineBuilder::PerformFirstSection
  const Standard_Real     Pdep,
  const Standard_Real     Pmax,
  const math_Vector&      ParDep,
- const Standard_Real     Tolesp,
+ const Standard_Real     the3DTolEsp,
  const Standard_Real     TolGuide,
  const Standard_Boolean  RecRst,
  const Standard_Boolean  RecP,
@@ -338,7 +337,7 @@ Standard_Boolean BRepBlend_SurfRstLineBuilder::PerformFirstSection
   iscomplete = Standard_False;
   comptra = Standard_False;
   line = new BRepBlend_Line();
-  tolesp = Abs(Tolesp);
+  my3DTolEsp = Abs(the3DTolEsp);
   tolgui = Abs(TolGuide);
   rebrou = Standard_False;
   
@@ -353,7 +352,7 @@ Standard_Boolean BRepBlend_SurfRstLineBuilder::PerformFirstSection
   Standard_Boolean recadp,recadrst,recads;
   Standard_Real wp,wrst,ws;
   Standard_Real U = 0.,V = 0.;
-  math_Vector infbound(1,3),supbound(1,3),tolerance(1,3);
+  math_Vector infbound(1,3),supbound(1,3),aVTol2D(1,3);
   math_Vector solinvp(1,3),solinvrst(1,4),solinvs(1,3);
   Handle(Adaptor3d_HVertex) Vtxp,Vtxrst,Vtxs,Vtxc;
   Standard_Boolean IsVtxp = 0,IsVtxrst = 0,IsVtxs = 0;
@@ -361,10 +360,10 @@ Standard_Boolean BRepBlend_SurfRstLineBuilder::PerformFirstSection
   wp = wrst = ws = Pmax;
   param = Pdep;
   Func.Set(param);
-  Func.GetTolerance(tolerance,tolesp);
+  Func.GetTolerance(aVTol2D, my3DTolEsp);
   Func.GetBounds(infbound,supbound);
 
-  math_FunctionSetRoot rsnld(Func,tolerance,30);
+  math_FunctionSetRoot rsnld(Func, aVTol2D, 30);
   rsnld.Perform(Func,ParDep,infbound,supbound);
   if (!rsnld.IsDone()) return Standard_False;
   rsnld.Root(sol);
@@ -526,7 +525,7 @@ void BRepBlend_SurfRstLineBuilder::InternalPerform(Blend_SurfRstFunction&  Func,
   Standard_Real U = 0.,V = 0.;
   Standard_Real trst = 0.;
   math_Vector infbound(1,3),supbound(1,3);
-  math_Vector parinit(1,3),tolerance(1,3);
+  math_Vector parinit(1,3),aVTol2D(1,3);
   math_Vector solinvp(1,3),solinvrst(1,4),solinvs(1,3);
   Handle(Adaptor3d_HVertex) Vtxp,Vtxrst,Vtxs,Vtxc;
   Standard_Boolean IsVtxp = 0,IsVtxrst = 0,IsVtxs = 0;
@@ -535,10 +534,10 @@ void BRepBlend_SurfRstLineBuilder::InternalPerform(Blend_SurfRstFunction&  Func,
 
   //IntSurf_Transition Tline,Tarc;
 
-  Func.GetTolerance(tolerance,tolesp);
+  Func.GetTolerance(aVTol2D, my3DTolEsp);
   Func.GetBounds(infbound,supbound);
 
-  math_FunctionSetRoot rsnld(Func,tolerance,30);
+  math_FunctionSetRoot rsnld(Func, aVTol2D, 30);
   parinit = sol;
 
   Arrive = Standard_False;
@@ -743,9 +742,8 @@ void BRepBlend_SurfRstLineBuilder::InternalPerform(Blend_SurfRstFunction&  Func,
 	
 	if (param == Bound) {
 	  Arrive = Standard_True;
-	  Exts.SetValue(previousP.PointOnS(),
-			sol(1),sol(2),
-			previousP.Parameter(),tolesp);
+	  Exts.SetValue(previousP.PointOnS(), sol(1),sol(2),
+                        previousP.Parameter(), my3DTolEsp);
 	  MakeExtremity(Extrst,Standard_False,rst,sol(3),IsVtxrst,Vtxrst);
 	  // Indicate end on Bound.
 	}
@@ -764,10 +762,9 @@ void BRepBlend_SurfRstLineBuilder::InternalPerform(Blend_SurfRstFunction&  Func,
 	if (Abs(stepw) < tolgui) {
 	  previousP.ParametersOnS(U,V);
 	  Exts.SetValue(previousP.PointOnS(),U,V,
-			previousP.Parameter(),tolesp);
-	  Extrst.SetValue(previousP.PointOnC(),
-			  previousP.ParameterOnC(),
-			  previousP.Parameter(),tolesp);
+                        previousP.Parameter(), my3DTolEsp);
+	  Extrst.SetValue(previousP.PointOnC(), previousP.ParameterOnC(),
+                          previousP.Parameter(), my3DTolEsp);
 	  Arrive = Standard_True;
 	  if (line->NbPoints()>=2) {
 	    // Indicate that one stops during the processing
@@ -803,7 +800,7 @@ void BRepBlend_SurfRstLineBuilder::InternalPerform(Blend_SurfRstFunction&  Func,
 	if (param == Bound) {
 	  Arrive = Standard_True;
 	  Exts.SetValue(previousP.PointOnS(),sol(1),sol(2),
-			previousP.Parameter(),tolesp);
+                        previousP.Parameter(), my3DTolEsp);
 	  MakeExtremity(Extrst,Standard_False,rst,sol(3),IsVtxrst,Vtxrst);
 	  // Indicate end on Bound.
 	}
@@ -849,7 +846,7 @@ void BRepBlend_SurfRstLineBuilder::InternalPerform(Blend_SurfRstFunction&  Func,
 	  line->Prepend(previousP);
 	}
 	Exts.SetValue(previousP.PointOnS(),sol(1),sol(2),
-		      previousP.Parameter(),tolesp);
+                      previousP.Parameter(), my3DTolEsp);
 	MakeExtremity(Extrst,Standard_False,rst,sol(3),IsVtxrst,Vtxrst);
 	Arrive = Standard_True;
       }
@@ -882,10 +879,10 @@ void BRepBlend_SurfRstLineBuilder::InternalPerform(Blend_SurfRstFunction&  Func,
 #endif
 	previousP.ParametersOnS(U,V);
 	Exts.SetValue(previousP.PointOnS(),U,V,
-		      previousP.Parameter(),tolesp);
+                      previousP.Parameter(), my3DTolEsp);
 	Extrst.SetValue(previousP.PointOnC(),
 			previousP.ParameterOnC(),
-			previousP.Parameter(),tolesp);
+                        previousP.Parameter(), my3DTolEsp);
 	Arrive = Standard_True;
       }
       break;
@@ -929,24 +926,24 @@ Standard_Boolean BRepBlend_SurfRstLineBuilder::Recadre(Blend_SurfCurvFuncInv&
     return Standard_False;
   }
 
-  domain1->Init();
+  myDomain1->Init();
   nbarc = 1;
   while (nbarc < IndexSol) {
     nbarc++;
-    domain1->Next();
+    myDomain1->Next();
   }
-  Arc = domain1->Value();
+  Arc = myDomain1->Value();
 
   FinvC.Set(Arc);
   
-  math_Vector toler(1,3),infb(1,3),supb(1,3);
-  FinvC.GetTolerance(toler,tolesp);
+  math_Vector aVTol2D(1,3),infb(1,3),supb(1,3);
+  FinvC.GetTolerance(aVTol2D, my3DTolEsp);
   FinvC.GetBounds(infb,supb);
   Solinv(1) = param;
   Solinv(2) = sol(3);
   Solinv(3) = pmin;
   
-  math_FunctionSetRoot rsnld(FinvC,toler,30);
+  math_FunctionSetRoot rsnld(FinvC,aVTol2D,30);
   rsnld.Perform(FinvC,Solinv,infb,supb);
 
   if (!rsnld.IsDone()) {
@@ -957,7 +954,7 @@ Standard_Boolean BRepBlend_SurfRstLineBuilder::Recadre(Blend_SurfCurvFuncInv&
   else {
       // It is necessary to check the value of the function
     rsnld.Root(Solinv);
-    recadre = FinvC.IsSolution(Solinv,tolesp);
+    recadre = FinvC.IsSolution(Solinv, my3DTolEsp);
   }
 
   // In case of fail, it is checked if another arc 
@@ -970,22 +967,22 @@ Standard_Boolean BRepBlend_SurfRstLineBuilder::Recadre(Blend_SurfCurvFuncInv&
       return Standard_False; // No other solution
     }
 
-    domain1->Init();
+    myDomain1->Init();
     nbarc = 1;
     while (nbarc < IndexSol) {
       nbarc++;
-      domain1->Next();
+      myDomain1->Next();
     }
 
-    Arc = domain1->Value();
+    Arc = myDomain1->Value();
     FinvC.Set(Arc);
   
-    FinvC.GetTolerance(toler,tolesp);
+    FinvC.GetTolerance(aVTol2D, my3DTolEsp);
     FinvC.GetBounds(infb,supb);
 
     Solinv(3) = pmin;
   
-    math_FunctionSetRoot aRsnld(FinvC,toler,30);
+    math_FunctionSetRoot aRsnld(FinvC,aVTol2D,30);
     aRsnld.Perform(FinvC,Solinv,infb,supb);
 
     if (!aRsnld.IsDone()) {
@@ -996,31 +993,31 @@ Standard_Boolean BRepBlend_SurfRstLineBuilder::Recadre(Blend_SurfCurvFuncInv&
     else {
       // It is necessary to check the value of the function
       aRsnld.Root(Solinv);
-      recadre = FinvC.IsSolution(Solinv,tolesp);
+      recadre = FinvC.IsSolution(Solinv, my3DTolEsp);
     }
   }  
 
   if (recadre) {
     Standard_Real w = Solinv(2);
-    if(w < rst->FirstParameter() - toler(2)||
-       w > rst->LastParameter() + toler(2)){
+    if((aVTol2D(2) < (rst->FirstParameter() - w)) ||
+       ((w - rst->LastParameter()) > aVTol2D(2))){
       return Standard_False;
     }
-    domain1->Initialize(Arc);
-    domain1->InitVertexIterator();
-    IsVtx = !domain1->MoreVertex();
+    myDomain1->Initialize(Arc);
+    myDomain1->InitVertexIterator();
+    IsVtx = !myDomain1->MoreVertex();
     while (!IsVtx) {
-      Vtx = domain1->Vertex();
+      Vtx = myDomain1->Vertex();
       if (Abs(BRepBlend_BlendTool::Parameter(Vtx,Arc)-Solinv(3)) <=
 	  BRepBlend_BlendTool::Tolerance(Vtx,Arc)) {
 	IsVtx = Standard_True;
       }
       else {
-	domain1->NextVertex();
-	IsVtx = !domain1->MoreVertex();
+        myDomain1->NextVertex();
+        IsVtx = !myDomain1->MoreVertex();
       }
     }
-    if (!domain1->MoreVertex()) {
+    if (!myDomain1->MoreVertex()) {
       IsVtx = Standard_False;
     }
     return Standard_True;
@@ -1039,15 +1036,15 @@ Standard_Boolean BRepBlend_SurfRstLineBuilder::Recadre(Blend_SurfRstFunction&
 						       Standard_Boolean&        IsVtx,
 						       Handle(Adaptor3d_HVertex)& Vtx) 
 {
-  math_Vector toler(1,4),infb(1,4),supb(1,4);
-  Finv.GetTolerance(toler,tolesp);
+  math_Vector aVTol2D(1,4),infb(1,4),supb(1,4);
+  Finv.GetTolerance(aVTol2D, my3DTolEsp);
   Finv.GetBounds(infb,supb);
   Solinv(1) = sol(3);
   Solinv(2) = param;
   Solinv(3) = sol(1);
   Solinv(4) = sol(2);
 
-  math_FunctionSetRoot rsnld(Finv,toler,30);
+  math_FunctionSetRoot rsnld(Finv,aVTol2D,30);
   rsnld.Perform(Finv,Solinv,infb,supb);
   if (!rsnld.IsDone()) {
 #ifdef OCCT_DEBUG
@@ -1057,38 +1054,38 @@ Standard_Boolean BRepBlend_SurfRstLineBuilder::Recadre(Blend_SurfRstFunction&
   }
   rsnld.Root(Solinv);
   
-  if(Finv.IsSolution(Solinv,tolesp)){
+  if (Finv.IsSolution(Solinv, my3DTolEsp)){
     gp_Pnt2d p2d(Solinv(3),Solinv(4));
-    TopAbs_State situ = domain1->Classify(p2d,Min(toler(3),toler(4)),0);
+    TopAbs_State situ = myDomain1->Classify(p2d, my3DTolEsp, Standard_False);
     if ((situ != TopAbs_IN) && (situ != TopAbs_ON)) {
       return Standard_False;
     }
-    domain2->Initialize(rst);
-    domain2->InitVertexIterator();
-    IsVtx = !domain2->MoreVertex();
+    myDomain2->Initialize(rst);
+    myDomain2->InitVertexIterator();
+    IsVtx = !myDomain2->MoreVertex();
     while (!IsVtx) {
-      Vtx = domain2->Vertex();
+      Vtx = myDomain2->Vertex();
       if (Abs(BRepBlend_BlendTool::Parameter(Vtx,rst)-Solinv(1)) <=
 	  BRepBlend_BlendTool::Tolerance(Vtx,rst)) {
 	IsVtx = Standard_True;
       }
       else {
-	domain2->NextVertex();
-	IsVtx = !domain2->MoreVertex();
+	myDomain2->NextVertex();
+	IsVtx = !myDomain2->MoreVertex();
       }
     }
-    if (!domain2->MoreVertex()) {
+    if (!myDomain2->MoreVertex()) {
       IsVtx = Standard_False;
     }
     // The section is recalculated by direct resolution, otherwise 
     // incoherences between the parameter and the ground caused by yawn are returned.
 
     math_Vector infbound(1,3),supbound(1,3);
-    math_Vector parinit(1,3),tolerance(1,3);
-    Func.GetTolerance(tolerance,tolesp);
+    math_Vector parinit(1,3),aVTol2D(1,3);
+    Func.GetTolerance(aVTol2D, my3DTolEsp);
     Func.GetBounds(infbound,supbound);
 
-    math_FunctionSetRoot rsnld2(Func,tolerance,30);
+    math_FunctionSetRoot rsnld2(Func,aVTol2D,30);
     parinit(1) = Solinv(3);
     parinit(2) = Solinv(4);
     parinit(3) = Solinv(1);
@@ -1124,14 +1121,14 @@ Standard_Boolean BRepBlend_SurfRstLineBuilder::Recadre(Blend_SurfPointFuncInv&
   gp_Pnt thepoint = surf2->Value(p2drst.X(),p2drst.Y());
 
   FinvP.Set(thepoint);
-  math_Vector toler(1,3),infb(1,3),supb(1,3);
-  FinvP.GetTolerance(toler,tolesp);
+  math_Vector aVTol2D(1,3),infb(1,3),supb(1,3);
+  FinvP.GetTolerance(aVTol2D, my3DTolEsp);
   FinvP.GetBounds(infb,supb);
   Solinv(1) = param;
   Solinv(2) = sol(1);
   Solinv(3) = sol(2);
 
-  math_FunctionSetRoot rsnld(FinvP,toler,30);
+  math_FunctionSetRoot rsnld(FinvP,aVTol2D,30);
   rsnld.Perform(FinvP,Solinv,infb,supb);
   if (!rsnld.IsDone()) {
 #ifdef OCCT_DEBUG
@@ -1141,27 +1138,27 @@ Standard_Boolean BRepBlend_SurfRstLineBuilder::Recadre(Blend_SurfPointFuncInv&
   }
   rsnld.Root(Solinv);
   
-  if(FinvP.IsSolution(Solinv,tolesp)){
+  if (FinvP.IsSolution(Solinv, my3DTolEsp)){
     gp_Pnt2d p2d(Solinv(2),Solinv(3));
-    TopAbs_State situ = domain1->Classify(p2d,Min(toler(2),toler(3)),0);
+    TopAbs_State situ = myDomain1->Classify(p2d, my3DTolEsp, Standard_False);
     if ((situ != TopAbs_IN) && (situ != TopAbs_ON)) {
       return Standard_False;
     }
-    domain2->Initialize(rst);
-    domain2->InitVertexIterator();
-    IsVtx = !domain2->MoreVertex();
+    myDomain2->Initialize(rst);
+    myDomain2->InitVertexIterator();
+    IsVtx = !myDomain2->MoreVertex();
     while (!IsVtx) {
-      Vtx = domain2->Vertex();
+      Vtx = myDomain2->Vertex();
       if (Abs(BRepBlend_BlendTool::Parameter(Vtx,rst)-wpoint) <=
 	  BRepBlend_BlendTool::Tolerance(Vtx,rst)) {
 	IsVtx = Standard_True;
       }
       else {
-	domain2->NextVertex();
-	IsVtx = !domain2->MoreVertex();
+        myDomain2->NextVertex();
+        IsVtx = !myDomain2->MoreVertex();
       }
     }
-    if (!domain2->MoreVertex()) {
+    if (!myDomain2->MoreVertex()) {
       IsVtx = Standard_False;
     }
     return Standard_True;
@@ -1234,20 +1231,18 @@ void BRepBlend_SurfRstLineBuilder::MakeExtremity(BRepBlend_Extremity&
   Standard_Real prm;
   Handle(Adaptor3d_TopolTool) Iter;
   if (OnFirst) {
-    Extrem.SetValue(previousP.PointOnS(),
-		    sol(1),sol(2),
-		    previousP.Parameter(),tolesp);
+    Extrem.SetValue(previousP.PointOnS(), sol(1),sol(2),
+                    previousP.Parameter(),my3DTolEsp);
     if (!previousP.IsTangencyPoint()) 
       Extrem.SetTangent(previousP.TangentOnS());
-    Iter = domain1;
+    Iter = myDomain1;
   }
   else {
-    Extrem.SetValue(previousP.PointOnC(),
-		    sol(3),
-		    previousP.Parameter(),tolesp);
+    Extrem.SetValue(previousP.PointOnC(), sol(3),
+                    previousP.Parameter(), my3DTolEsp);
     if (!previousP.IsTangencyPoint()) 
       Extrem.SetTangent(previousP.TangentOnC());    
-    Iter = domain2;
+    Iter = myDomain2;
   }
   
   Iter->Init();
@@ -1311,12 +1306,12 @@ Blend_Status BRepBlend_SurfRstLineBuilder::CheckDeflectionOnSurf(const Blend_Poi
 //  if(!curpointistangent) curNorme = Tgsurf.SquareMagnitude();
   if(!prevpointistangent) prevNorme = prevTg.SquareMagnitude();
 
-  if (Norme <= tolesp*tolesp){
+  if (Norme <= my3DTolEsp*my3DTolEsp){
     // it can be necessary to force same point
     return Blend_SamePoints;
   }
   if(!prevpointistangent){
-    if(prevNorme <= tolesp*tolesp) {
+    if (prevNorme <= my3DTolEsp*my3DTolEsp) {
       return Blend_SamePoints;
     }
     Cosi = sens*Corde*prevTg;
@@ -1387,12 +1382,12 @@ Blend_Status BRepBlend_SurfRstLineBuilder::CheckDeflectionOnRst(const Blend_Poin
 //  if(!curpointistangent) curNorme = Tgsurf.SquareMagnitude();
   if(!prevpointistangent) prevNorme = prevTg.SquareMagnitude();
 
-  if (Norme <= tolesp*tolesp){
+  if (Norme <= my3DTolEsp*my3DTolEsp){
     // it can be necessary to force same point
     return Blend_SamePoints;
   }
   if(!prevpointistangent){
-    if(prevNorme <= tolesp*tolesp) {
+    if (prevNorme <= my3DTolEsp*my3DTolEsp) {
       return Blend_SamePoints;
     }
     Cosi = sens*Corde*prevTg;
@@ -1454,7 +1449,7 @@ Blend_Status BRepBlend_SurfRstLineBuilder::TestArret(Blend_SurfRstFunction& Func
   IntSurf_TypeTrans tras = IntSurf_Undecided, trarst = IntSurf_Undecided;
   Blend_Point curpoint;
 
-  if (Func.IsSolution(sol,tolesp)) {
+  if (Func.IsSolution(sol, my3DTolEsp)) {
     Standard_Boolean curpointistangent = Func.IsTangencyPoint();
     pts = Func.PointOnS();
     ptrst = Func.PointOnRst();
@@ -1498,7 +1493,7 @@ Blend_Status BRepBlend_SurfRstLineBuilder::TestArret(Blend_SurfRstFunction& Func
       Func.Decroch(sol,nors,tgsecs);
       nors.Normalize();
       Standard_Real testra = tgsecs.Dot(nors.Crossed(tgs));
-      if (Abs(testra) > tolesp) {
+      if (Abs(testra) > my3DTolEsp) {
 	if (testra < 0.) {
 	  tras = IntSurf_In;
 	}
@@ -1508,7 +1503,7 @@ Blend_Status BRepBlend_SurfRstLineBuilder::TestArret(Blend_SurfRstFunction& Func
 	gp_Pnt2d p2drstref; gp_Vec2d tg2drstref;
 	rst->D1(sol(3),p2drstref,tg2drstref);
 	testra = tg2drst.Dot(tg2drstref);
-	TopAbs_Orientation Or = domain2->Orientation(rst);
+	TopAbs_Orientation Or = myDomain2->Orientation(rst);
 	if (Abs(testra) > 1.e-8) {
 	  if (testra < 0.) {
 	    trarst = ConvOrToTra(TopAbs::Reverse(Or));
@@ -1556,23 +1551,25 @@ Standard_Boolean BRepBlend_SurfRstLineBuilder::CheckInside(Blend_SurfRstFunction
 							   TopAbs_State&          SituOnS,
 							   Standard_Boolean&      Decroch)
 {
-  math_Vector tolerance(1,3);
-  Func.GetTolerance(tolerance,tolesp);
+  math_Vector aVTol2D(1,3);
+  Func.GetTolerance(aVTol2D, my3DTolEsp);
   //face pcurve.
   Standard_Real w = sol(3);
-  if(w < rst->FirstParameter() - tolerance(3)||
-     w > rst->LastParameter() + tolerance(3)){
+  if((aVTol2D(3) < (rst->FirstParameter() - w)) ||
+     ((w - rst->LastParameter()) > aVTol2D(3)))
+  {
     SituOnC = TopAbs_OUT;
   }
   else if (w > rst->FirstParameter() &&
-	   w < rst->LastParameter()){
+           w < rst->LastParameter())
+  {
     SituOnC = TopAbs_IN;
   }
   else SituOnC = TopAbs_ON;
 
   //face surface
   gp_Pnt2d p2d(sol(1),sol(2));
-  SituOnS = domain1->Classify(p2d,Min(tolerance(1),tolerance(2)),0);
+  SituOnS = myDomain1->Classify(p2d, my3DTolEsp, Standard_False);
 
   //lost contact
   gp_Vec tgs,nors;
diff --git a/src/BRepBlend/BRepBlend_SurfRstLineBuilder.hxx b/src/BRepBlend/BRepBlend_SurfRstLineBuilder.hxx
index 62c2330..d9aa145 100644
--- a/src/BRepBlend/BRepBlend_SurfRstLineBuilder.hxx
+++ b/src/BRepBlend/BRepBlend_SurfRstLineBuilder.hxx
@@ -133,11 +133,11 @@ private:
   Handle(BRepBlend_Line) line;
   math_Vector sol;
   Handle(Adaptor3d_HSurface) surf1;
-  Handle(Adaptor3d_TopolTool) domain1;
+  Handle(Adaptor3d_TopolTool) myDomain1;
   Handle(Adaptor3d_HSurface) surf2;
   Handle(Adaptor2d_HCurve2d) rst;
-  Handle(Adaptor3d_TopolTool) domain2;
-  Standard_Real tolesp;
+  Handle(Adaptor3d_TopolTool) myDomain2;
+  Standard_Real my3DTolEsp;
   Standard_Real tolgui;
   Standard_Real pasmax;
   Standard_Real fleche;
diff --git a/src/BRepBlend/BRepBlend_Walking.hxx b/src/BRepBlend/BRepBlend_Walking.hxx
index 974703c..5f837e7 100644
--- a/src/BRepBlend/BRepBlend_Walking.hxx
+++ b/src/BRepBlend/BRepBlend_Walking.hxx
@@ -101,13 +101,6 @@ public:
 
 protected:
 
-
-
-
-
-private:
-
-  
   Standard_EXPORT void InternalPerform (Blend_Function& F, Blend_FuncInv& FInv, const Standard_Real Bound);
   
   Standard_EXPORT Standard_Boolean CorrectExtremityOnOneRst (const Standard_Integer IndexOfRst, const Standard_Real theU, const Standard_Real theV, const Standard_Real theParam, const gp_Pnt& thePntOnRst, Standard_Real& NewU, Standard_Real& NewV, gp_Pnt& NewPoint, Standard_Real& NewParam) const;
@@ -127,21 +120,25 @@ private:
   Standard_EXPORT Blend_Status TestArret (Blend_Function& F, const Blend_Status State, const Standard_Boolean TestDeflection = Standard_True, const Standard_Boolean TestSolution = Standard_True, const Standard_Boolean TestLengthStep = Standard_False);
 
 
+
+
+private:
+
   Blend_Point previousP;
   Handle(BRepBlend_Line) line;
   math_Vector sol;
   Blend_SequenceOfPoint jalons;
   Handle(Adaptor3d_HSurface) surf1;
   Handle(Adaptor3d_HSurface) surf2;
-  Handle(Adaptor3d_TopolTool) domain1;
-  Handle(Adaptor3d_TopolTool) domain2;
-  Handle(Adaptor3d_TopolTool) recdomain1;
-  Handle(Adaptor3d_TopolTool) recdomain2;
+  Handle(Adaptor3d_TopolTool) myDomain1;
+  Handle(Adaptor3d_TopolTool) myDomain2;
+  Handle(Adaptor3d_TopolTool) myRecDomain1;
+  Handle(Adaptor3d_TopolTool) myRecDomain2;
   Handle(ChFiDS_HElSpine) hguide;
   Standard_Boolean ToCorrectOnRst1;
   Standard_Boolean ToCorrectOnRst2;
   Standard_Real CorrectedParam;
-  Standard_Real tolesp;
+  Standard_Real my3DTolEsp;
   Standard_Real tolgui;
   Standard_Real pasmax;
   Standard_Real fleche;
diff --git a/src/BRepBndLib/BRepBndLib.cxx b/src/BRepBndLib/BRepBndLib.cxx
index b739683..5d3a8e9 100644
--- a/src/BRepBndLib/BRepBndLib.cxx
+++ b/src/BRepBndLib/BRepBndLib.cxx
@@ -693,7 +693,8 @@ void AdjustFaceBox(const BRepAdaptor_Surface& BS,
                    const Standard_Real umin, const Standard_Real umax, 
                    const Standard_Real vmin, const Standard_Real vmax,
                    Bnd_Box& FaceBox,
-                   const Bnd_Box& EdgeBox, const Standard_Real Tol)
+                   const Bnd_Box& EdgeBox,
+                   const Standard_Real Tol)
 {
   Standard_Real fxmin, fymin, fzmin, fxmax, fymax, fzmax;
   Standard_Real exmin, eymin, ezmin, exmax, eymax, ezmax;
@@ -701,9 +702,9 @@ void AdjustFaceBox(const BRepAdaptor_Surface& BS,
   FaceBox.Get(fxmin, fymin, fzmin, fxmax, fymax, fzmax);
   EdgeBox.Get(exmin, eymin, ezmin, exmax, eymax, ezmax);
   //
-  Standard_Real TolU = Max(BS.UResolution(Tol), Precision::PConfusion());
-  Standard_Real TolV = Max(BS.VResolution(Tol), Precision::PConfusion());
-  BRepTopAdaptor_FClass2d FClass(BS.Face(), Max(TolU, TolV));
+  BRepTopAdaptor_FClass2d FClass(BS.Face(), Tol);
+  const Standard_Real TolU = Max(BS.UResolution(Tol), Precision::PConfusion());
+  const Standard_Real TolV = Max(BS.VResolution(Tol), Precision::PConfusion());
   //
   Standard_Boolean isModified = Standard_False;
   if(exmin > fxmin)
diff --git a/src/BRepCheck/BRepCheck_Face.cxx b/src/BRepCheck/BRepCheck_Face.cxx
index fd500c5..3b53dc1 100644
--- a/src/BRepCheck/BRepCheck_Face.cxx
+++ b/src/BRepCheck/BRepCheck_Face.cxx
@@ -323,9 +323,17 @@ BRepCheck_Status BRepCheck_Face::ClassifyWires(const Standard_Boolean Update)
     newFace.Orientation(TopAbs_FORWARD);
     B.Add(newFace,wir1);
 
-    BRepTopAdaptor_FClass2d FClass2d(newFace,Precision::PConfusion());
+    BRepTopAdaptor_FClass2d FClass2d(newFace,Precision::Confusion());
     Standard_Boolean WireBienOriente = Standard_False;
-    if(FClass2d.PerformInfinitePoint() != TopAbs_OUT) { 
+    TopAbs_State aState = FClass2d.PerformInfinitePoint();
+    if (aState == TopAbs_UNKNOWN) {
+      myOrires = BRepCheck_UnorientableShape;
+      if (Update) {
+        BRepCheck::Add(myMap(myShape), myOrires);
+      }
+      return myOrires;
+    }
+    if (aState == TopAbs_IN) {
       WireBienOriente=Standard_True;
       // the given wire defines a hole
       myMapImb.UnBind(wir1);
diff --git a/src/BRepClass/BRepClass_FClass2dOfFClassifier.hxx b/src/BRepClass/BRepClass_FClass2dOfFClassifier.hxx
index 492066a..84b8a33 100644
--- a/src/BRepClass/BRepClass_FClass2dOfFClassifier.hxx
+++ b/src/BRepClass/BRepClass_FClass2dOfFClassifier.hxx
@@ -19,22 +19,13 @@
 
 #include <Standard.hxx>
 #include <Standard_DefineAlloc.hxx>
-#include <Standard_Handle.hxx>
 
-#include <Standard_Boolean.hxx>
-#include <gp_Lin2d.hxx>
-#include <Standard_Real.hxx>
-#include <TopTrans_CurveTransition.hxx>
 #include <BRepClass_Intersector.hxx>
-#include <Standard_Integer.hxx>
 #include <TopAbs_State.hxx>
-#include <TopAbs_Orientation.hxx>
-class Standard_DomainError;
-class BRepClass_Edge;
-class BRepClass_Intersector;
-class gp_Lin2d;
-
+#include <TopTrans_CurveTransition.hxx>
 
+class gp_Lin2d;
+class TopClass_GeomEdge;
 
 class BRepClass_FClass2dOfFClassifier 
 {
@@ -49,13 +40,15 @@ public:
   //! Starts  a  classification process.   The  point to
   //! classify is the origin of  the  line <L>.  <P>  is
   //! the original length of the segment on <L>  used to
-  //! compute  intersections.   <Tol> is the   tolerance
-  //! attached to the line segment in intersections.
-  Standard_EXPORT void Reset (const gp_Lin2d& L, const Standard_Real P, const Standard_Real Tol);
+  //! compute  intersections.
+  Standard_EXPORT void Reset (const gp_Lin2d& L, const Standard_Real P);
   
   //! Updates  the classification process with  the edge
-  //! <E> from the boundary.
-  Standard_EXPORT void Compare (const BRepClass_Edge& E, const TopAbs_Orientation Or);
+  //! <theE> from the boundary.
+  //! theTol2D is 2D-tolerance using in intersector of theE with
+  //! the linear ray myLin
+  Standard_EXPORT void Compare(const TopClass_GeomEdge& theE,
+                               const Standard_Real theTol2D);
   
   //! Returns the current value of the parameter.
     Standard_Real Parameter() const;
@@ -77,36 +70,22 @@ public:
   //! otherwise.
     Standard_Boolean IsHeadOrEnd() const;
 
-
-
-
 protected:
 
-
-
-
-
 private:
 
-
-
-  Standard_Boolean myIsSet;
   Standard_Boolean myFirstCompare;
   Standard_Boolean myFirstTrans;
   gp_Lin2d myLin;
   Standard_Real myParam;
-  Standard_Real myTolerance;
+
   TopTrans_CurveTransition myTrans;
   BRepClass_Intersector myIntersector;
   Standard_Integer myClosest;
   TopAbs_State myState;
   Standard_Boolean myIsHeadOrEnd;
-
-
 };
 
-#define TheEdge BRepClass_Edge
-#define TheEdge_hxx <BRepClass_Edge.hxx>
 #define TheIntersector BRepClass_Intersector
 #define TheIntersector_hxx <BRepClass_Intersector.hxx>
 #define TopClass_Classifier2d BRepClass_FClass2dOfFClassifier
@@ -114,14 +93,9 @@ private:
 
 #include <TopClass_Classifier2d.lxx>
 
-#undef TheEdge
-#undef TheEdge_hxx
 #undef TheIntersector
 #undef TheIntersector_hxx
 #undef TopClass_Classifier2d
 #undef TopClass_Classifier2d_hxx
 
-
-
-
 #endif // _BRepClass_FClass2dOfFClassifier_HeaderFile
diff --git a/src/BRepClass/BRepClass_FClass2dOfFClassifier_0.cxx b/src/BRepClass/BRepClass_FClass2dOfFClassifier_0.cxx
index d31e426..8420ba4 100644
--- a/src/BRepClass/BRepClass_FClass2dOfFClassifier_0.cxx
+++ b/src/BRepClass/BRepClass_FClass2dOfFClassifier_0.cxx
@@ -17,13 +17,10 @@
 #include <BRepClass_FClass2dOfFClassifier.hxx>
 
 #include <Standard_DomainError.hxx>
-#include <BRepClass_Edge.hxx>
+#include <TopClass_GeomEdge.hxx>
 #include <BRepClass_Intersector.hxx>
 #include <gp_Lin2d.hxx>
- 
 
-#define TheEdge BRepClass_Edge
-#define TheEdge_hxx <BRepClass_Edge.hxx>
 #define TheIntersector BRepClass_Intersector
 #define TheIntersector_hxx <BRepClass_Intersector.hxx>
 #define TopClass_Classifier2d BRepClass_FClass2dOfFClassifier
